<template>
  <div>
    <v-form>
      <div class="t-tway">Suscripción y Pago</div>
      <v-container fluid>
        <v-row class="ma-0">
          <v-col class="ma-0" cols="12" xs="12" sm="12" md="3" lg="3" xl="3">
            <div class="text-subtitle-1 roboto mb-2">Plan Seleccionado</div>
            <v-card class="ma-2 rounded-card">
              <v-card-text>
                <v-row
                  class="text-h5 text--tway-violet mb-4 mt-4"
                  justify="center"
                >
                  <div class="text-capitalize">
                    Plan {{ this.planName.toLowerCase() }}
                  </div>
                </v-row>

                <v-row class="ma-0" justify="center">
                  <strong
                    class="mb-4 text-body-2 text--primary font-weight-bold"
                    >Incluye:</strong
                  >
                </v-row>
                <div v-if="planName === 'FREE'" class="text--primary">
                  <v-row
                    class="ma-0"
                    v-for="(link, index) in clientType === 'CLIENT'
                      ? linksClient.free
                      : linksSpecialist.free"
                    :key="index"
                  >
                    <v-col class="ma-0" cols="10">
                      <span class="text-t roboto">{{ link }}</span>
                    </v-col>
                    <v-col class="ma-0 pa-0" cols="2" align-self="center">
                      <v-row class="ma-0 pa-0" justify="end">
                        <v-img
                          :src="require('@/assets/img/check.svg')"
                          class="rounded"
                          max-width="40%"
                        />
                      </v-row>
                    </v-col>
                  </v-row>
                </div>
                <div v-if="planName === 'STARTER'" class="text--primary">
                  <v-row
                    class="ma-0"
                    v-for="(link, index) in clientType === 'CLIENT'
                      ? linksClient.starter
                      : linksSpecialist.starter"
                    :key="index"
                  >
                    <v-col class="ma-0" cols="10">
                      <span class="text-t roboto">{{ link }}</span>
                    </v-col>
                    <v-col class="ma-0 pa-0" cols="2" align-self="center">
                      <v-row class="ma-0 pa-0" justify="end">
                        <v-img
                          :src="require('@/assets/img/check.svg')"
                          class="rounded"
                          max-width="40%"
                        />
                      </v-row>
                    </v-col>
                  </v-row>
                </div>
                <div v-if="planName === 'BUSINESS'" class="text--primary">
                  <v-row
                    class="ma-0"
                    v-for="(link, index) in clientType === 'CLIENT'
                      ? linksClient.business
                      : linksSpecialist.business"
                    :key="index"
                  >
                    <v-col class="ma-0" cols="10">
                      <span class="text-t roboto">{{ link }}</span>
                    </v-col>
                    <v-col class="ma-0 pa-0" cols="2" align-self="center">
                      <v-row class="ma-0 pa-0" justify="end">
                        <v-img
                          :src="require('@/assets/img/check.svg')"
                          class="rounded"
                          max-width="40%"
                        />
                      </v-row>
                    </v-col>
                  </v-row>
                </div>
                <div v-if="planName === 'BEST FIT'" class="text--primary">
                  <v-row
                    class="ma-0"
                    v-for="(link, index) in clientType === 'CLIENT'
                      ? linksClient.bestfit
                      : linksSpecialist.bestfit"
                    :key="index"
                  >
                    <v-col class="ma-0" cols="10">
                      <span class="text-t roboto">{{ link }}</span>
                    </v-col>
                    <v-col class="ma-0 pa-0" cols="2" align-self="center">
                      <v-row class="ma-0 pa-0" justify="end">
                        <v-img
                          :src="require('@/assets/img/check.svg')"
                          class="rounded"
                          max-width="40%"
                        />
                      </v-row>
                    </v-col>
                  </v-row>
                </div>
              </v-card-text>
            </v-card>
            <v-row justify="center" class="mt-4">
              <a
                v-if="desktop"
                @click="
                  () => {
                    $router.go(-1);
                  }
                "
                class="select-plan roboto"
                >Seleccionar otro Plan</a
              >
              <a
                v-if="mobile"
                @click="
                  () => {
                    $router.go(-1);
                  }
                "
                class="select-plan pl-12 roboto"
                >Seleccionar otro Plan</a
              >
            </v-row>
          </v-col>
          <v-col class="ma-0" cols="12" xs="12" sm="12" md="4" lg="4" xl="4">
            <div class="text-subtitle-1 roboto mb-2">
              Selecciona el tiempo de suscripción
            </div>
            <v-card class="rounded-card2">
              <v-card-text>
                <v-radio-group column v-model="subscription.period">
                  <v-radio
                    v-for="(
                      paymentType, key
                    ) in planConstants.SubscriptionPeriod"
                    :key="key"
                    :label="paymentType"
                    :value="key"
                    class="card-promo roboto mb-5"
                    color="tway-violet"
                  />
                </v-radio-group>
              </v-card-text>
            </v-card>
            <div class="text-subtitle-1 roboto mb-2 mt-2">
              Selecciona la forma de pago
            </div>
            <v-card class="rounded-card2">
              <v-card-text>
                <v-radio-group column v-model="selectedPaymentType">
                  <v-radio
                    v-for="(paymentType, key) in planConstants.PaymentType2"
                    :key="key"
                    :label="paymentType.label"
                    :value="key"
                    :disabled="paymentType.disabled"
                    class="text-subtitle-1 roboto mb-5"
                    color="tway-violet"
                  />
                </v-radio-group>
              </v-card-text>
            </v-card>
            <div class="text-subtitle-1 roboto mb-2 mt-2">
              Selecciona el medio de pago
            </div>
            <v-card class="rounded-card2">
              <v-card-text>
                <v-radio-group column v-model="selectedPaymentMethod">
                  <v-radio
                    color="tway-violet"
                    class="text-subtitle-1 roboto mb-5"
                    value="WEBPAY_PLUS_NORMAL"
                  >
                    <template v-slot:label>
                      <v-img
                        :src="
                          require(`@/assets/img/1.WebpayPlus_FB_300px 1.png`)
                        "
                        contain
                        max-height="100"
                        max-width="150"
                      />
                    </template>
                  </v-radio>
                  <v-radio
                    color="tway-violet"
                    class="text-subtitle-1 roboto"
                    value="WEBPAY_ONE_CLICK"
                    disabled
                  >
                    <template v-slot:label>
                      <v-img
                        :src="require(`@/assets/img/oneclick.png`)"
                        contain
                        max-height="100"
                        max-width="150"
                      />
                      <div
                        class="text-subtitle-3 roboto mt-3 ml-1"
                        :style="mobile ? 'font-size:10px' : 'font-size:16px'"
                      >
                        (Próximamente)
                      </div>
                    </template>
                  </v-radio>
                  <v-radio
                    color="tway-violet"
                    class="text-subtitle-1 roboto"
                    value="PAYPAL"
                  >
                    <template v-slot:label>
                      <v-img
                        :src="require(`@/assets/img/paypal.png`)"
                        contain
                        max-height="100"
                        max-width="150"
                      />
                    </template>
                  </v-radio>
                  <v-radio
                    color="tway-violet"
                    class="text-subtitle-1 roboto"
                    value="PAYU"
                  >
                    <template v-slot:label>
                      <v-img
                        :src="require(`@/assets/img/payu.svg`)"
                        contain
                        max-height="33"
                        max-width="79"
                      />
                    </template>
                  </v-radio>
                </v-radio-group>
              </v-card-text>
            </v-card>
          </v-col>
          <v-col class="ma-0" cols="12" xs="12" sm="12" md="5" lg="5" xl="5">
            <v-card
              v-if="
                $store.getters['subscription/getValidateSubscription'] == true
              "
              class="card-promo pa-4 mb-3 rounded-card-promo"
            >
              Suscribiéndote, obtendrás un
              <span class="font-weight-bold">50% de descuento</span> en entradas
              para la Conferencia de
              <span class="font-weight-bold"
                >Transformación Digital 2021 de World Class Business
                Leaders</span
              >
            </v-card>
            <v-card class="pa-4 rounded-card2">
              <v-card-text>
                <v-row
                  class="tway-title black-text mb-6"
                  style="font-size: 25px"
                  justify="start"
                >
                  <div>Resumen</div>
                </v-row>
                <v-row class="text-h5 text--tway-violet mb-4" justify="start">
                  <div class="text-capitalize" style="font-size: 20px">
                    Plan {{ this.planName.toLowerCase() }}
                  </div>
                </v-row>
                <v-row justify="space-between" class="mb-5">
                  <div class="roboto black-text" style="font-size: 16px">
                    Tiempo de suscripción
                  </div>
                  <div
                    v-if="subscription.period == 'YEARLY'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    Anual
                  </div>
                  <div
                    v-if="subscription.period == 'QUARTERLY'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    Trimestral
                  </div>
                </v-row>
                <v-row justify="space-between" class="mb-5">
                  <div class="roboto black-text" style="font-size: 16px">
                    Forma de pago
                  </div>
                  <div
                    v-if="selectedPaymentType == 'ONE_PAYMENT'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    Un Solo Pago
                  </div>
                  <div
                    v-if="selectedPaymentType == 'MONTHLY_PAYMENT'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    {{ totalPrice.installments }} pagos de
                    {{ totalPrice.installmentValue | currency }}
                  </div>
                </v-row>
                <v-row justify="space-between" class="mb-5">
                  <div class="roboto black-text" style="font-size: 16px">
                    Medio de pago
                  </div>
                  <div
                    v-if="selectedPaymentMethod === 'WEBPAY_PLUS_NORMAL'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    WebPay
                  </div>
                  <div
                    v-if="selectedPaymentMethod === 'PAYPAL'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    PayPal
                  </div>
                  <div
                    v-if="selectedPaymentMethod === 'PAYU'"
                    class="roboto black-text"
                    style="font-size: 16px"
                  >
                    PayU
                  </div>
                </v-row>
                <v-divider />
                <v-row justify="space-between mt-10">
                  <div class="summary-text black-text font-weight-bold">
                    Total a Pagar:
                  </div>
                  <div class="summary-text black-text font-weight-bold">
                    <span>{{ totalPrice.price | currency }}</span>
                    {{ plans.currency }}
                  </div>
                </v-row>
                <v-row class="mt-8" justify="center">
                  <v-checkbox
                    color="success"
                    v-model="acceptTermsAndConditions"
                  >
                    <template v-slot:label>
                      <div>
                        <a
                          target="_blank"
                          @click.stop="modalTerms = true"
                          class="violet-text"
                        >
                          Acepto los términos y condiciones de uso
                        </a>
                      </div>
                    </template>
                  </v-checkbox>
                </v-row>

                <v-dialog
                  class="modal-dialog modal-sm"
                  v-model="modalTerms"
                  :max-width="desktop ? '714' : '343'"
                >
                  <v-card>
                    <div class="text-h6 ml- pa-5">
                      Términos y condiciones de uso
                    </div>

                    <v-card-text>
                      <iframe
                        class="iframe"
                        src="https://static-dev.tway.cl/terms/terminos.pdf"
                        :height="desktop ? '350' : '400'"
                        :width="desktop ? '670' : '300'"
                      />
                    </v-card-text>

                    <v-card-actions>
                      <v-row justify="center" class="ma-0 pa-0">
                        <a
                          class="tway-violet--text ma-2 pa-2 pr-15 roboto"
                          v-if="desktop"
                          @click.stop="modalTerms = false"
                        >
                          VOLVER
                        </a>
                        <v-btn
                          v-if="desktop"
                          large
                          rounded
                          color="tway-violet"
                          class="white--text ma-2 roboto"
                          @click.stop="modalTerms = false"
                        >
                          ACEPTAR
                        </v-btn>
                      </v-row>
                      <v-row v-if="!desktop" justify="center">
                        <v-row justify="center" class="ma-0 pa-0">
                          <a
                            class="tway-violet--text pa-3 pr-5 roboto"
                            @click.stop="modalTerms = false"
                          >
                            VOLVER
                          </a>
                          <v-btn
                            x-large
                            rounded
                            color="tway-violet"
                            class="white--text roboto"
                            @click.stop="modalTerms = false"
                          >
                            ACEPTAR
                          </v-btn>
                        </v-row>
                      </v-row>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
                <v-card-actions>
                  <v-row class="mt-2">
                    <v-btn
                      rounded
                      color="tway-apple-green"
                      block
                      class="white--text roboto"
                      @click="submitSubscription"
                      :disabled="!canSubmit || !acceptTermsAndConditions"
                      :loading="isLoading"
                    >
                      PAGAR SUSCRIPCIÓN
                    </v-btn>
                  </v-row>
                </v-card-actions>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-form>
    <transbank-form
      :webpay-plus="true"
      :ready="transactionReady"
      :url="url"
      :token="token"
    />
    <paypal-form
      v-if="paypalSubscriptionReady"
      :subscription="subscription"
      :accepttermsandconditions="acceptTermsAndConditions"
      :plans="plans"
      :totalprice="totalPrice"
      :paypalclientid="paypalclientid"
      :paypalplanid="paypalplanid"
      :product="product"
      @close="
        () => {
          paypalSubscriptionReady = false;
        }
      "
    />
    <paypalcheckout-form
      v-if="paypalCheckoutReady"
      :subscription="subscription"
      :accepttermsandconditions="acceptTermsAndConditions"
      :plans="plans"
      :totalprice="totalPrice"
      :paypalclientid="paypalclientid"
      :paypalplanid="paypalplanid"
      :product="product"
      @close="
        () => {
          paypalCheckoutReady = false;
        }
      "
    />
  </div>
</template>

<script>
import { mapActions } from "vuex";
import oneclickService from "@/services/billing/oneclickService";
import planService from "@/services/planService";
import subscriptionService from "@/services/subscriptionService";
import ValidatorsService from "@/services/validatorsService";
import planConstants from "@/utils/planConstants.json";
import currentUserService from "@/services/currentUserService";
import CompanyService from "@/services/companyService";
import PaypalSubscription from "@/views/Subscription/PaypalSubscription";
import PaypalCheckout from "@/views/Subscription/PaypalCheckout";

export default {
  name: "Subscribe",
  components: {
    "paypal-form": PaypalSubscription,
    "paypalcheckout-form": PaypalCheckout,
  },

  data: () => ({
    user: null,
    transactionReady: false,
    paypalSubscriptionReady: false,
    paypalCheckoutReady: false,
    url: "",
    token: "",
    isLoading: true,
    planConstants: planConstants,
    modalTerms: false,
    clientType: "",
    loadingText: "",
    selectedPlanType: "",
    selectedPaymentType: "",
    selectedPaymentMethod: "",
    plans: [],
    dolar: {
      fecha: "",
      valor: "",
    },
    planName: "",
    // plan
    selectedPlan: {
      id: null,
      name: "",
      type: "",
      price: 0,
      currencyCode: "",
      features: [],
    },
    subscription: {
      planId: "",
      period: "YEARLY",
      paymentMethod: "",
    },
    // oneclick enroll cards
    loadingEnrollCard: false,
    selectedEnrolledCard: null,
    oneClickEnrolledCards: [],
    loadingEnrolledCards: false,
    // webpayplus
    loadingWebpayPlus: false,
    acceptTermsAndConditions: false,
    linksClient: {
      free: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
      ],
      starter: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
        "Dashboard con Brechas y Desafíos Estratégicos en Transformación",
      ],
      business: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
        "Dashboard con Brechas y Desafíos Estratégicos en Transformación",
        "Ranking Tway de Especialistas validados con servicios para la transformación de tu negocio",
        "Licitación a la Medida y acompañamiento de PMO Digital en Transformación Estratégica SÓLO 1 TRIMESTRAL",
        "Cobro Adicional $350 USD Nueva Licitación y PMO Digital de Transformación Estratégica.",
      ],
      bestfit: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
        "Dashboard con Brechas y Desafíos Estratégicos en Transformación",
        "Ranking Tway de Especialistas validados con servicios para la transformación de tu negocio",
        "Licitación a la Medida y acompañamiento de PMO Digital en Transformación Estratégica CUPOS ILIMITADOS",
        "Orquestación para gestionar la Transformación Estratégica (Governance)",
      ],
    },
    linksSpecialist: {
      free: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
        "Benchmark e información de mercado e industria",
      ],
      starter: [
        "Contenidos y Tendencias",
        "Encuesta para diagnosticar Índice de Madurez en Transformación Digital de tu Empresa",
        "Dashboard con Ranking y Benchmark de la competencia",
      ],
      business: [
        "Contenidos y Tendencias",
        "Índice de Madurez en Transformación Digital",
        "Dashboard con Brechas y Desafíos Estratégicos en Transformación",
        "Ranking Tway de Especialistas validados con servicios para la transformación de tu negocio",
        "Licitación a la Medida y acompañamiento de PMO Digital en Transformación Estratégica SÓLO 1 TRIMESTRAL",
        "Cobro Adicional $350 USD Nueva Licitación y PMO Digital de Transformación Estratégica.",
      ],
      bestfit: [
        "Contenidos y Tendencias",
        "Índice de Madurez en Transformación Digital",
        "Dashboard con Brechas y Desafíos Estratégicos en Transformación",
        "Ranking Tway de Especialistas validados con servicios para la transformación de tu negocio",
        "Licitación a la Medida y acompañamiento de PMO Digital en Transformación Estratégica CUPOS ILIMITADOS",
      ],
    },
    loadedPaypal: false,
    paidFor: false,
    product: {
      price: 777,
      description: "description",
      img: "./assets/img/Tway-logotipo-gris.png",
    },
  }),
  computed: {
    availablePlans: function () {
      return this.plans.filter(
        (p) => p.name !== "STARTER" && p.type === this.selectedPlanType
      );
    },
    totalPrice: function () {
      let total = {};

      total.price = this.plans.price;

      if (this.subscription.period === "YEARLY") {
        total.price = this.plans.price * 10;
        if (this.selectedPaymentType === "ONE_PAYMENT") {
          total.installments = 1;
          total.installmentValue = total.price;
        } else if (this.selectedPaymentType === "MONTHLY_PAYMENT") {
          total.installments = 12;
          total.installmentValue = total.price / 12;
        }
      } else {
        if (this.subscription.period === "QUARTERLY") {
          total.price = this.plans.price * 3;
          if (this.selectedPaymentType === "ONE_PAYMENT") {
            total.installments = 1;
            total.installmentValue = total.price;
          } else if (this.selectedPaymentType === "MONTHLY_PAYMENT") {
            total.installments = 3;
            total.installmentValue = total.price / 3;
          }
        }
      }

      return total;
    },
    canSubmit: function () {
      if (!this.acceptTermsAndConditions) {
        return false;
      }

      if (!this.subscription.period) {
        return false;
      }

      if (!this.selectedPaymentType) {
        return false;
      }

      if (!this.selectedPaymentMethod) {
        return false;
      }

      return true;
    },

    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },

  created() {
    this.isLoading = false;
    this.getPlans();
    this.getCompany();
  },

  methods: {
    ...mapActions("subscription", ["setSubscription"]),

    required: (propertyType) => ValidatorsService.required(propertyType),
    paypalInit() {
      this.loaded = true;

      let data = {
        period: this.subscription.period,
        paymentMethod: "",
        clientId: localStorage.getItem("userId"),
        planId: this.$route.params.plan,
        sessionId: localStorage.getItem("accessToken"),
      };

      if (this.selectedPaymentType === "MONTHLY_PAYMENT") {
        this.subscription.paymentMethod = "PAYPAL_SUBSCRIPTION";
        data.paymentMethod = this.subscription.paymentMethod;
        subscriptionService
          .subscribe(data)
          .then((response) => {
            if (response.paymentMethodInfo.meta) {
              this.paypalclientid =
                response.paymentMethodInfo.meta.paypalClientID;
              this.paypalplanid = response.paymentMethodInfo.meta.paypalPlanId;
              this.paypalSubscriptionReady = true;
            }
          })
          .catch((err) => this.$log.error(err));
      } else if (this.selectedPaymentType === "ONE_PAYMENT") {
        this.subscription.paymentMethod = "PAYPAL_CHECKOUT";
        data.paymentMethod = this.subscription.paymentMethod;
        subscriptionService
          .subscribe(data)
          .then((response) => {
            if (response.paymentMethodInfo.meta) {
              this.paypalclientid =
                response.paymentMethodInfo.meta.paypalClientID;
              this.paypalplanid = response.paymentMethodInfo.meta.paypalPlanId;
              this.paypalCheckoutReady = true;
            }
          })
          .catch((err) => this.$log.error(err));
      } else {
        this.$log.error("PaymentType not supported");
      }
    },
    getPlans: function () {
      planService
        .findPlan(this.$route.params.plan)
        .then((plans) => ((this.plans = plans), (this.planName = plans.name)))
        .catch((err) => this.$log.error("Unexpected error: ", err))
        .then(() => (this.isLoading = false));
    },
    getCompany() {
      CompanyService.getCompanyProfile()
        .then((company) => (this.clientType = this._.get(company, "type")))
        .catch((err) => console.log(err));
      currentUserService
        .currentUserData()
        .then((userData) => (this.user = userData))
        .catch((err) => this.$log.error(err));
    },
    submitSubscription() {
      let paymentMethod = this.selectedPaymentMethod;
      if (paymentMethod === "WEBPAY_PLUS_NORMAL") {
        this.webpayInit();
      }
      if (paymentMethod === "PAYPAL") {
        this.paypalInit();
      }
      if (paymentMethod === "PAYU") {
        this.payUInit();
      }
    },
    webpayInit() {
      this.subscription.paymentMethod = this.selectedPaymentMethod;
      this.isLoading = true;
      let Data = {
        period: this.subscription.period,
        paymentMethod: this.subscription.paymentMethod,
        clientId: localStorage.getItem("userId"),
        planId: this.$route.params.plan,
        sessionId: localStorage.getItem("accessToken"),
      };

      if (this.subscription.paymentMethod === "WEBPAY_PLUS_NORMAL") {
        subscriptionService
          .subscribe(Data)
          .then((response) => {
            if (response.paymentMethodInfo.meta) {
              this.url = response.paymentMethodInfo.meta.url;
              this.token = response.paymentMethodInfo.meta.token;
              this.transactionReady = true;
            }
          })
          .catch((err) => this.$log.error(err));
      }
    },
    payUInit() {
      this.subscription.paymentMethod = this.selectedPaymentMethod;
      this.isLoading = true;

      let data = {
        period: this.subscription.period,
        paymentMethod:
          this.selectedPaymentType === "MONTHLY_PAYMENT"
            ? "PAYU_SUBSCRIPTION"
            : "PAYU_SINGLE_PAY",
        clientId: localStorage.getItem("userId"),
        planId: this.$route.params.plan,
        sessionId: localStorage.getItem("accessToken"),
      };

      subscriptionService
        .subscribe(data)
        .then((response) => {
          let params = {
            ...response,
            planName: this.planName,
            price: this.totalPrice.price,
            paymentType: this.selectedPaymentType,
          };
          this.$router.push({ name: "payu", params });
        })
        .catch((err) => this.$log.error(err));
    },

    getOneClickEnrolledCard: function () {
      this.loadingEnrolledCards = true;
      oneclickService
        .getEnrolledCards()
        .then((cards) => {
          this.oneClickEnrolledCards = cards;
          this.selectedEnrolledCard = cards.length > 0 ? cards[0] : null;
        })
        .catch((err) => this.$log.error("Unexpected error: ", err))
        .finally(() => (this.loadingEnrolledCards = false));
    },

    enrollCardOnOneclick: function () {
      this.loadingEnrollCard = true;
      oneclickService
        .enrollCard()
        .then((url) => {
          this.loadingEnrollCard = false;

          // Como evitar bloqueo de popup?
          let enrollWindow = window.open(
            url,
            "_blank",
            "width=500, height=600, top=100"
          );
          enrollWindow.onclose = () => this.getOneClickEnrolledCard();
        })
        .catch((err) => {
          this.$log.error("Unexpected error: ", err);
          this.loadingEnrollCard = false;
        });
    },
  },
};
</script>

<style lang="scss">
.list-item-icon {
  margin-right: 0px !important;
}

.selected-payment-method-check {
  position: absolute;
}

.payment-selector {
  cursor: pointer;
  padding: 20px;
  display: flex;
}

.payment-input-selector {
  display: none;
}

.selected-billing-method {
  // border-color: rgba(0, 0, 0, 0.6)!important;
  border-color: $tway-apple-green !important;
  border-width: 2px;
}
.t-tway {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 25px;
  line-height: 32px;
}
.tway-title {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: bold;
  font-size: 24px;
  line-height: 24px;
}
.black-text {
  color: #333333;
}
.grey-text {
}
.violet-text {
  color: #7319d5 !important;
}
.border {
  border-bottom: 1px solid #333333;
}
.text-modal {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal;
  font-size: 12px;
  line-height: 24px;
}
.select-plan {
  text-align: center;
  font-size: 16px;
  line-height: 24px;
  color: #7319d5 !important;
  text-decoration: underline;
}
.card-promo {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;

  color: #333333 !important;
}
.rounded-card {
  border-radius: 40px !important;
}

.rounded-card2 {
  border-radius: 20px !important;
}
.rounded-card-promo {
  border-radius: 20px !important;
  border: 1px solid #7319d5 !important;
}
.summary-text {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: bold;
  font-size: 24px;
  line-height: 20px;
}
</style>
